RESDIR=Figs
RESULTSER=jeff.histos jeff.overlays jeff jeff.histo jeff.error error1 error2
RESULTSNR=ref


Math_base.x: Math_base.o math.o



h3d.H: ${BINDIR}/histo3d.x combo.H
	Window3d < combo.H f4=110 squeeze=n n4=1 |${BINDIR}/histo3d.x >$@


combo.v:	combo.H
	Window3d < combo.H n1=1 f1=0 |Transp |Grey axiscol=0 color=j newclip=1 out=a1.v label1="Depth(m)" label2="X Position(m)" title="Vertical velocity"
	Window3d < combo.H n1=1  f1=1|Transp |Grey axiscol=0 color=j newclip=1 out=a2.v label1="Depth(m)" label2="X Position(m)" title="Eta"
	Window3d < combo.H n1=1  f1=2|Transp |Grey axiscol=0 color=j newclip=1 out=a3.v label1="Depth(m)" label2="X Position(m)" title="Delta"
	pstexpen a1.v v1.ps color=y invras=y fat=5 fatmult=1.3
	pstexpen a2.v v2.ps color=y invras=y fat=5 fatmult=1.3
	pstexpen a3.v v3.ps color=y invras=y fat=5 fatmult=1.3
	epstopdf v1.ps
	epstopdf v2.ps
	epstopdf v3.ps

#make local versionm of the velocity,delta, epsilon
%.H: %.HH
	Window3d< $*.HH > $@

jeff2.H:  jeff_in.H ${BINDIR}/Lloyd_vel.x
	Lloyd_vel.x  niter_lloyd=50 nref=100 nstart=10,10 scales=11000,1 \
          < jeff_in.H >$@

jeffb.H:  jeff_in.H ${BINDIR}/Lloyd_vel.x
	Lloyd_vel.x vel_map=y niter_lloyd=50 nref=100 nstart=10,10 scales=11000,1 \
          < jeff_in.H >$@ niter_lloyd=0

jeff.H:  jeff_in.H ${BINDIR}/Lloyd_vel.x
	Lloyd_vel.x vel_map=y niter_lloyd=50 nref=400 nstart=10,10 scales=11000,1 \
          < jeff_in.H >$@

jeff.histo.H:	jeff_in.H ${BINDIR}/histo.x
	Window3d < jeff_in.H |Transp reshape=1,3 >a.H
	${BINDIR}/histo.x < a.H >$@

jeff.histos.H:	jeff_in.H ${BINDIR}/histo.x
	Window3d < jeff_in.H  |Transp reshape=1,3 |Transp plane=24  >a.H
	${BINDIR}/histo.x < a.H >$@

${RESDIR}/jeff.error.v: #jeff.H jeffb.H
	Math_base file1=jeffb.H file2=jeff_in.H exp="(file1-file2)/(file2)*100." >b1.H
	Math_base file1=jeff.H file2=jeff_in.H exp="(file1-file2)/(file2)*100." >b2.H
	Window3d < b1.H |Transp |Transp plane=23 |Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" " wantframenum=n clip=20 wantscalebar=y barlabel="Error pct" >a1.V 
	Window3d < b2.H |Transp |Transp plane=23 |Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" "  wantframenum=n clip=20 wantscalebar=y barlabel="Error pct" >a2.V
	Vppen gridnum=2,2 < a1.V a2.V vpstyle=n >c.V out=$@
	Window3d < b1.H |Transp |Transp plane=23 |Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" " wantframenum=n clip=20 wantscalebar=y barlabel="Error pct" >a1.V color=j axiscol=0
	Window3d < b2.H |Transp |Transp plane=23 |Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" "  wantframenum=n clip=20 wantscalebar=y barlabel="Error pct" >a2.V color=j axiscol=0
	Vppen vpstyle=n < a1.V a2.V >b.V out=a.v
	vppen   < a.v out0=a1.v out1=a2.v out2=a3.v out3=a4.v
	pstexpen a1.v jeff.e1.ps color=y invras=y fat=5 fatmult=1.3
	pstexpen a2.v jeff.e2.ps color=y invras=y fat=5 fatmult=1.3
	pstexpen a3.v jeff.e3.ps color=y invras=y fat=5 fatmult=1.3
	pstexpen a4.v jeff.e4.ps color=y invras=y fat=5 fatmult=1.3
	epstopdf jeff.e1.ps
	epstopdf jeff.e2.ps
	epstopdf jeff.e3.ps
	epstopdf jeff.e4.ps

HISTOS=10 40 200

RANGE=min1=.000139 max1=.000388 min2=.51 max2=7.8

${RESDIR}/jeff.histo.v:# jeff.histo.H
	< jeff.histo.H Grey ${RANGE} title=" " label1="A" label2="B" >a.V  allpos=y  pclip=98 out=$@

${RESDIR}/jeff.v: #jeff_in.H
	Window3d < jeff_in.H |Transp |Transp plane=23|Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" " allpos=y wantframenum=n |Vppen gridnum=2,1 out=$@ >a.V vpstyle=n
	Window3d < jeff_in.H n1=1 |Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" " allpos=y newclip=1 color=j out=a1.v axiscol=0
	Window3d < jeff_in.H f1=1 |Transp |Grey gainpanel=e label1="Depth(m)" label2="X Position(m)" title=" " allpos=y newclip=1 color=j out=a2.v axiscol=0
	pstexpen a1.v jeff.in1.ps color=y invras=y fat=5 fatmult=1.3
	pstexpen a2.v jeff.in2.ps color=y invras=y fat=5 fatmult=1.3
	epstopdf jeff.in1.ps
	epstopdf jeff.in2.ps


jeff.histo%.V: #jeff.histos.H
	Window3d < jeff.histos.H  f4=$* n4=1|Grey ${RANGE} title=" " label1="A" label2="B" clip=5 >$@ crowd=.8 allpos=y clip=3 axiscol=0
	Window3d < jeff.histos.H  f4=$* n4=1|Grey ${RANGE} title=" " label1="A" label2="B" clip=5 out=a.v crowd=.8 allpos=y clip=3  axiscol=0
	pstexpen a.v jeff.histo$*.ps color=y invras=y fat=5 fatmult=1.3
	epstopdf jeff.histo$*.ps


jeff.overlay%.V: #jeff.histo%.V # jeff2.H
	Window3d < jeff2.H f4=$* n4=1 | Transp |Graph ${RANGE} esize=8 n2=1 n1=100 symbol="*" >z.V wantaxis=n title=" " label1=" " label2=" " transp=y crowd=.8 yreverse=y symbolsz=20
	Vppen erase=o jeff.histo$*.V z.V >$@ vpstyle=n out=a.v
	pstexpen a.v jeff.overlay$*.ps color=y invras=y fat=5 fatmult=1.3
	epstopdf jeff.overlay$*.ps


${RESDIR}/jeff.overlays.v: #${addsuffix .V,${addprefix jeff.overlay, ${HISTOS}}}
	Vppen ${addsuffix .V,${addprefix jeff.overlay, ${HISTOS}}} >a.V out=$@ vpstyle=n gridnum=3,1

${RESDIR}/jeff.histos.v: #${addsuffix .V,${addprefix jeff.histo, ${HISTOS}}}
	Vppen ${addsuffix .V,${addprefix jeff.histo, ${HISTOS}}} >a.V out=$@ vpstyle=n gridnum=3,1




#Create a file so we can test different partitioning parameters
combo.H: pv.H eta.H delta.H
	Cat pv.H eta.H delta.H axis=3 |Transp reshape=2,3 |Transp plane=34 >$@


compare.%.H: 
	Lloyd_vel < vel.$*.H >a1.H vel_map=y  nref=15 nrand=0 min_slow_dev=6 min_region_pct=.02 lloyd_new=y
	Lloyd_vel < vel.$*.H >a2.H vel_map=y  nref=15 nrand=0 min_slow_dev=6 
	Math_base file1=a1.H file2=vel.$*.H exp="(file1-file2)/file2*100." >b1.H
	Math_base file1=a2.H file2=vel.$*.H exp="(file1-file2)/file2*100." > b2.H
	Cat vel.$*.H a1.H a2.H axis=2 |Transp plane=23 |Transp plane=12 >compare.$*.H
	Cat b1.H b2.H axis=2 |Transp  plane=23 |Transp >error.$*.H

DO=title=" " label1="Depth(m)" label2="X Position(m)" title=" "
${RESDIR}/error1.v:  #vel.a.H
	Lloyd_vel < vel.a.H >a1.H vel_map=y nref=15 min_slow_dev=9
	Math_base file1=a1.H file2=vel.a.H exp="(file1-file2)/file2*100." >b1.H
	Window3d < vel.a.H   |Transp |Grey  ${DO} >a1.V bias=1.5 allpos=y
	Window3d < a1.H   |Transp |Grey  ${DO} >a2.V bias=1.5 allpos=y
	Window3d < b1.H   |Transp |Grey  ${DO} >a3.V wantscalebar=y barlabel="Error pct." clip=4.
	Vppen gridnum=3,1 < a1.V a2.V a3.V vpstyle=n >c.V out=$@

${RESDIR}/error2.v:  #vel.a.H
	Lloyd_vel < vel.a.H >a2.H vel_map=y nref=15 min_slow_dev=9 lloyd_new=y min_region_pct=0.02
	Math_base file1=a2.H file2=vel.a.H exp="(file1-file2)/file2*100." >b2.H
	Window3d < a2.H   |Transp |Grey  ${DO} >a2.V bias=1.5 allpos=y
	Window3d < b2.H    |Transp |Grey ${DO} >a3.V wantscalebar=y barlabel="Error pct." clip=4
	Vppen gridnum=2,1 < a2.V a3.V vpstyle=n >c.V out=$@



map.H values.H: ${BINDIR}/Lloyd_vel.x lloyd.P combo.H
	${BINDIR}/Lloyd_vel.x <  combo.H >values.H par=lloyd.P
	${BINDIR}/Lloyd_vel.x <  combo.H >map.H par=lloyd.P vel_map=y

err.H: map.H
	Math file1=map.H file2=combo.H exp="1./@ABS(file2+0.001)" >a.H
	Math file1=map.H file2=combo.H exp="100.0*(@ABS(file1-file2))/(@ABS(file1)+0.00001)" >a.H
	Window3d < a.H |Transp reshape=1,3 >$@	
	


zero.test.H: ${BINDIR}/Pre2D_vti_ssf_v14.x mig.P
	Window3d < pv.H >v.H j3=2 squeeze=n
	Window3d < eta.H >e.H j3=2 squeeze=n
	Window3d < delta.H >d.H j3=2 squeeze=n
	${BINDIR}/Pre2D_vti_ssf_v14.x par=mig.P  Data=zero.freq.H Slow=v.H \
          Vti_eta=e.H Vti_delta=d.H

full.H: freq.H mig.P
	Window3d < pv.H >v.H j3=1 squeeze=n
	Window3d < eta.H >e.H j3=1 squeeze=n
	Window3d < delta.H >d.H j3=1 squeeze=n
	python Test-mig-aniso.py par=mig.P \
	command=./Pre2D_vti_ssf_v14.x   data=freq.H slow=v.H \
          vti_eta=e.H vti_delta=d.H image=$@ nblock=416


depth.H:	
	Cat delta.HH eta.HH axis=2 | Window3d f3=100 n3=1|  Transp  plane=23> depth.H


histo.H:	depth.H ${BINDIR}/histo.x
	${BINDIR}/histo.x < depth.H >$@

iters.H: depth.H ${BINDIR}/Lloyd_fig.x
	Window3d < depth.H |Transp >a.H
	${BINDIR}/Lloyd_fig.x < a.H >$@  nstart=4,4 iter0=0 jiter=2 niter=10

iter.%.H: depth.H ${BINDIR}/Lloyd_fig.x
	Window3d < depth.H |Transp  >a.H	 
	${BINDIR}/Lloyd_fig.x < a.H >$@  nstart=10,10 nref=100 iter0=$* jiter=2 niter=1 min_region_pct=.05

view1:  iters.H
	Window3d < iters.H |Transp> m.H
	Window3d < m.H f1=1 squeeze=n >a1.H
	Window3d < m.H n1=1 squeeze=n >a2.H
	Cat axis=1 a1.H a2.H >m.H
	echo esize=8 n1=20 n2=1 n3=10 >> m.H
	Graph <m.H symbol="*" min2=.035 max2=.056 min1=0.02 max1=.092 yreverse=y	 >a.V
	Tube pixmaps=y < a.V

overlay.%.V: iter.%.H 
	Grey < histo.H newclip=1 min1=.035 max1=.056 min2=.02 max2=.092 >a1.V
	Window3d < iter.$*.H |Transp  >m.H
	Window3d < m.H f1=1 squeeze=n >a1.H
	Window3d < m.H n1=1 squeeze=n >a2.H
	Cat axis=1 a1.H a2.H >m.H
	echo esize=8 n1=100 n2=1 n3=1 >> m.H
	Graph <m.H symbol="*" min2=.035 max2=.056 min1=0.02 max1=.092 yreverse=y	 >a.V title=" " symbolsz=20
	Grey < histo.H newclip=1  min1=.035 max1=.056 min2=.02 max2=.092 >a2.V title=" " wantaxis=n
	Vppen erase=o vpstyle=n < a2.V a.V >$@

ABB=overlay.0.V overlay.2.V overlay.4.V overlay.6.V overlay.8.V
movie:  ${ABB}
#	Graph < depth.H  titles="Delta:Epsilon" label1="X Position" label2="Value" |Tube pixmaps=y
#	Grey <histo.H  label1="Delta" label2="Epsilon" title="Hit count" |Tube pixmaps=y
	Tube < ${ABB} pixmaps=y


view2:
	Grey < histo.H newclip=1  min1=.035 max1=.056 min2=.02 max2=.092|Tube pixmaps=y
 

#full.H: Test-mig-nosalt-py.P Test-mig.P
#        python Test-mig.py par=Test-mig-nosalt-py.P par=mig.P


